import { __rest } from "tslib";
import { registerComponent, registerAction, registerModules } from 'organik';
import { registerAndLoadIconProviders } from 'petals-ui/dist/icon';
import { setDefaultTheme } from './theme';
function createApp({ components, metadata = {}, theme = {} }) {
    if (components) {
        components.forEach(registerComponent);
    }
    const { actions, modules } = metadata;
    if (actions) {
        actions.forEach(action => registerAction(action));
    }
    if (modules) {
        registerModules(modules);
    }
    const { icon = {} } = theme, otherThemeOptions = __rest(theme, ["icon"]);
    if (icon.providers) {
        registerAndLoadIconProviders(icon.providers);
    }
    setDefaultTheme(otherThemeOptions, true);
    return {
        mount: (elementOrSelector = '#app') => { },
    };
}
export { createApp };
